<?php
/*
Plugin Name: Lenky Related Links
Plugin URI: http://www.lenky.net/
Description: Offer your Blog visitors more information by placing external related links to every post in your blog, and also increase your blog accessibility and traffic as your blog posts will be linked in other blogs.
Version: 1.0.7
Author: Tamer Mohsen
Author URI: http://www.lenky.net/
*/

/*  Copyright 2008 Lenky (email : plugin@lenky.net)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * Set file system path to wp-content.
 */
define('WP_CONTENT', dirname(dirname(str_replace(array('http://' . $_SERVER['HTTP_HOST'], 'https://' . $_SERVER['HTTP_HOST']), $_SERVER['DOCUMENT_ROOT'], get_bloginfo('template_url')))));
/**
 * Set cache directory.
 */
define('SIMPLEPIE_CACHEDIR', WP_CONTENT . '/plugins/lenkyex/cache');
/**
* Set simplepie.inc directory
*/

define('SIMPLEPIE_INC', WP_CONTENT . '/plugins/lenkyex/simplepie.inc');



function lenky_header(){
	/*global $wp_query; 
	$posty = $wp_query->post;
	$purly = get_permalink($posty->ID);*/

	echo'<style type="text/css">
	<!--

	.lenky {
	background-color: #EFEFEF;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-bottom-style: solid;
	border-top-color: #666666;
	border-right-color: #666666;
	border-bottom-color: #666666;
	border-left-color: #666666;
	border-right-style: none;
	border-left-style: none;
	}

	.lenky_list
	{
	padding-left:5px;
	margin-left:5px;
	font-size: 11px;
	}
	.styleSATlenky {
	color: #000000; 
	font-weight: bold; 
	font: Verdana; font-family: Verdana, Arial, Helvetica, sans-serif; 
	font-size: smaller;
	background-color: #EFEFEF;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-bottom-style: solid;
	border-top-color: #666666;
	border-right-color: #666666;
	border-bottom-color: #666666;
	border-left-color: #666666;
	border-right-style: none;
	border-left-style: none;

	}


	-->
	</style>
	
<script type="text/javascript" src="http://lenky.net/plugin/prototype.js"></script>
<script type="text/javascript" src="http://lenky.net/plugin/Modal.js"></script>


<style>
    #modal_container {  
        padding:5px;  
        background-color:#fff;  
        border:1px solid #666;  
     	overflow:auto;  
        font-family:"Lucida Grande",Verdana;  
      	font-size:12px;  
       	color:#333;  
      	text-align:left;  
   } 
   
  	#modal_overlay {  
       background-color:#000;  
   }  
</style>


';
echo"
<script>
function track (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}
function track1 (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}
function track2 (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}
function track3 (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}
function track4 (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}
function track5 (link)
{
	
    new Image().src = 'http://www.lenky.net/plugin/track_click.php?u='+link.href;
	

}

</script>

";
}
add_filter('wp_head','lenky_header');





	

function check_p($content)
	{
	
	$lenky_home = get_option('lenkyhome');
	$lenky_single = get_option('lenkysingle');
	$lenky_page = get_option('lenkypage');
	
	$lenky_category = "Dont Show";
	$lenky_date = "Dont Show";
	$lenky_search = "Dont Show";
			
	$html = "";
	$lenkytext = get_option('lenkytext');
	////////post data////////
	global $wp_query; 
	$post2 = $wp_query->post;
	$purl = urlencode(get_permalink($post2->ID));
	$ctitle=$post1->post_title;
	$ptitle = urlencode($post2->post_title);
	$blog_title = get_bloginfo('name');
	$atom_url=get_bloginfo('atom_url');
	$eatom_url=urlencode($atom_url);
	//blog title
	$eblog_title=urlencode($blog_title);
	
	//tags and cats
	$catts = wp_get_object_terms($post2->ID, 'category');
	$taggs = wp_get_object_terms($post2->ID, 'post_tag');
	
	///no of tags and cats///
	$no_of_tags=count($taggs);
	$no_of_cats=count($catts);
	
	//10cats//
	$catss1=get_object_vars($catts[0]);
	$catss2=get_object_vars($catts[1]);
	$catss3=get_object_vars($catts[2]);
	$catss4=get_object_vars($catts[3]);
	$catss5=get_object_vars($catts[4]);
	$catss6=get_object_vars($catts[5]);
	$catss7=get_object_vars($catts[6]);
	$catss8=get_object_vars($catts[7]);
	$catss9=get_object_vars($catts[8]);
	$catss10=get_object_vars($$catts[9]);
	
	//10tags//
	
	$tagss1=get_object_vars($taggs[0]);
	$tagss2=get_object_vars($taggs[1]);
	$tagss3=get_object_vars($taggs[2]);
	$tagss4=get_object_vars($taggs[3]);
	$tagss5=get_object_vars($taggs[4]);
	$tagss6=get_object_vars($taggs[5]);
	$tagss7=get_object_vars($taggs[6]);
	$tagss8=get_object_vars($taggs[7]);
	$tagss9=get_object_vars($taggs[8]);
	$tagss10=get_object_vars($taggs[9]);
	

	
	$dtaggname=''.$tagss1['name'].'+'.$tagss2['name'].'+'.$tagss3['name'].'+'.$tagss4['name'].'+'.$tagss5['name'].'+'.$tagss6['name'].'+'.$tagss7['name'].'+'.$tagss8['name'].'+'.$tagss9['name'].'+'.$tagss10['name'].'+';
	$dcattname=''.$catss1['name'].'+'.$catss2['name'].'+'.$catss3['name'].'+'.$catss4['name'].'+'.$catss5['name'].'+'.$catss6['name'].'+'.$catss7['name'].'+'.$catss8['name'].'+'.$catss9['name'].'+'.$catss10['name'].'+';

	$cattname=urlencode($dcattname);
	$taggname=urlencode($dtaggname);
	
	//fix 
if(!class_exists("SimplePie")){
require_once(SIMPLEPIE_INC);
}
	//end fix
	
	$feed2 = new SimplePie();
	$feed2->set_feed_url('http://lenky.net/plugin/check.php?url='.$purl.'&title='.$ptitle.'&tags='.$taggname.'&cats='.$cattname.'&no_of_tags='.$no_of_tags.'&no_of_cats='.$no_of_cats.'&atom_url='.$eatom_url.'');
	
	$feed2->set_cache_location(SIMPLEPIE_CACHEDIR);	
	
	$feed2->set_cache_duration(900);
	
	$feed2->init();
	
	$feed2->handle_content_type();
	
	
	foreach ($feed2->get_items() as $item2):
	$ti=$item2->get_title();
	if ($ti=="EXIST")
	$exist=1;
	else
	$exist=0;
	endforeach; 

if ($exist==1)
	{
	// get the rp links
	global $wp_query; 
	$post1 = $wp_query->post;
	$purl = urlencode(get_permalink($post1->ID));

	//fix 
if(!class_exists("SimplePie")){
require_once(SIMPLEPIE_INC);
}
	//end fix
	
	$feed1 = new SimplePie();
	$feed1->set_feed_url('http://lenky.net/plugin/getrplinks.php?url='.$purl.'');


	$feed1->set_cache_location(SIMPLEPIE_CACHEDIR);	
	
	$feed1->init();
	
	$feed1->handle_content_type();
	

	
	$html.='<p><strong class="lenky">'.$lenkytext.'</strong><a href="http://www.lenky.net"><img src="http://www.lenky.net/images/by_lenky.gif" title="Related Links" width="55" height="13" border="0" align="baseline" /></a></u><ul class="lenky_list">';
	
	
	for ( $i=0; $i<5 ; $i++){
	$itemi = $feed1->get_item($i);
	$url1=$itemi->get_permalink();
	$titlei=$itemi->get_title();
	$jQ=$i+1;
	if($url1=="" || $titlei==""){
	//do nothing *Next Release*
	}
	else
	 $html.='<li STYLE="list-style-image: url(http://lenky.net/images/bull.gif); font-size: 11px;"><a href="'.$url1.'" target="_blank" onclick="track'.$jQ.'(this)" >'.$titlei.'</a></li>';
	}
	
	$html.='<li STYLE="list-style-image: url(http://lenky.net/images/link_error.png); "><a href="http://lenky.net/plugin/reportAurl.php?u='.$purl.'" class="styleSATlenky" title="Not satisfied of the results?" id="modal_link">Results are not related?</a></li>
';

	$html.="<script>
    new Control.Modal('modal_link',{
       	iframe: true, 
		width: 560,
		height: 350
    });
</script>
";
    $html.='</ul></p>';


	}
else
	{
	$html.='<p><img src="http://lenky.net/plugin/images/soon.png" alt="Getting the related stuff for this post" width="300" height="60" /></p>';

	}
	
if ((is_home() && $lenky_home=="Show") || (is_single() && $lenky_single=="Show") || (is_page() && $lenky_page=="Show") || (is_category() && $lenky_category=="Show") || (is_date() && $lenky_date=="Show") || (is_search() && $lenky_search=="Show") || 0)
$content.=$html;
else
$content.="";

return $content;
}

add_filter('the_content','check_p');


// Plugin config/data setup
if (function_exists('register_activation_hook')) {
	
	register_activation_hook(__FILE__, 'lenky_reset');
}

function lenky_reset() {
	return lenky_restore_config(False);
}

// restore built-in defaults, optionally overwriting existing values
function lenky_restore_config($force=False) {

	// only display on single posts and pages by default
	if ($force or !get_option('lenkyhome'))
		update_option('lenkyhome', "Dont Show");
	if ($force or !get_option('lenkysingle'))
		update_option('lenkysingle', "Show");
	if ($force or !get_option('lenkypage'))
		update_option('lenkypage', "Show");
		
}

//The Admin Page
// Hook the admin_menu display to add admin page
add_action('admin_menu', 'lenky_admin_menu');
function lenky_admin_menu() {
    add_submenu_page('options-general.php', 'Lenky Plugin Options', 'Lenky Plugin Options', 10, __FILE__, 'lenky_adminpage');
}


function lenky_adminpage() {

if ($_REQUEST['save']) {


		if (!$_REQUEST['home'])
			$_REQUEST['home'] = "Dont Show";
		update_option('lenkyhome', $_REQUEST['home']);
		if (!$_REQUEST['single'])
			$_REQUEST['single'] = "Show";
		update_option('lenkysingle', $_REQUEST['single']);
		if (!$_REQUEST['page'])
			$_REQUEST['page'] = "Show";
		update_option('lenkypage', $_REQUEST['page']);

///
	
		if (!$_REQUEST['lenky_text'])
			$_REQUEST['lenky_text'] = "Related links to this post :";
		update_option('lenkytext', $_REQUEST['lenky_text']);
		
		//echo a pretty 'Options Edited' message
        echo "<div id=\"message\" class=\"updated fade\"><p><strong>Lenky plugin options updated.</strong></p></div>";

}

	$lenkyhome = get_option('lenkyhome');
	$lenkysingle = get_option('lenkysingle');
	$lenkypage = get_option('lenkypage');
	
	

	$lenky_text = get_option('lenkytext');
	
		if (empty($lenkyhome)){
		update_option('lenkyhome', "Dont Show");
		$lenkyhome = "Dont Show";
		}
		if (empty($lenkysingle)){
		update_option('lenkysingle', "Show");
		$lenkysingle = "Show";
		}
		if (empty($lenkypage)){
		update_option('lenkypage', "Show");
		$lenkypage = "Show";
		}

		if (empty($lenky_text)){
		update_option('lenkytext', 'Related links to this post :');
		$lenky_text = 'Related links to this post :';
		}
	
	if($lenkyhome=="Dont Show")
	$lenkySHOW1="Show";
	else
	$lenkySHOW1="Dont Show";
	
	if($lenkysingle=="Dont Show")
	$lenkySHOW2="Show";
	else
	$lenkySHOW2="Dont Show";
	
	if($lenkypage=="Dont Show")
	$lenkySHOW3="Show";
	else
	$lenkySHOW3="Dont Show";

    echo "<div class=\"wrap\">
    <h2>Lenky Plugin Options</h2>";
	
?>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">

<div>

<p><strong>Controls where you want the Lenky Related Links to show up.</strong></p>

<table width="329" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="185">Front page of the blog</td>
    <td width="144"><select name="home">
    <option selected="selected"><? echo $lenkyhome; ?></option>
    <option><? echo $lenkySHOW1; ?></option>
  </select></td>
  </tr>
  <tr>
    <td>Individual blog posts</td>
    <td>  <select name="single">
    <option selected="selected"><? echo $lenkysingle; ?></option>
    <option><? echo $lenkySHOW2; ?></option>
  </select></td>
  </tr>
  <tr>
    <td>Individual WordPress &quot;Pages&quot;</td>
    <td><select name="page">
    <option selected="selected"><? echo $lenkypage; ?></option>
    <option><? echo $lenkySHOW3; ?></option>
  </select></td>
  </tr>
</table>


<br />
<label><strong> Edit the &quot;Related links to this post :&quot; message :</strong> <input name="lenky_text" type="text" value="<? echo $lenky_text; ?>" size="35"  /></label>


<p><input name="save" value="Save Changes" type="submit" /></p>


</div>


</form>

<?php

print_r($conditionals);
}



?>